+++
title = "About Hitch Hiker Linux"
date = 2021-02-15
+++

```bash
#!/don't/panic
man 42
```
HitchHiker Linux is a very Unix-like distribution of Linux with a focus on
simplicity, elegance and providing a solid base that the end user can turn into
whatever they see fit.
## Core Principles:
* The default installation should include the bare minimum required
  software to provide a solid base.
* In itself, complexity is not bad. However, it must be justified, with
  a strong preference given to more robust and secure code over having
  every possible feature.
* End users should not be discouraged from tinkering with their system.
* The distribution should make as few assumptions as possible regarding end use.
* While newer releases of software often eliminate bugs and vulnerabilities,
  newer software packages are not by default more secure than stable,
  mature packages (newer is not always better).
* Any changes to the core system functionality, especially those which
  change expected functionality, must be well justified and well vetted
  before deployment.
* The base installation should include everything required to rebuild
  itself from source.
* The distribution should make as few changes to the upstream software
  as possible, delivering it as intended by the original author.
* Patching of sources should only be done to fix bugs or vulnerabilities.
* Power users and developers are users too, and the system should stay
  out of their way.

HHL was born of a desire to harness the greater hardware support of Linux while
paying respect to the Unix systems from which Linux was born. The author was a
long time user of FreeBSD who migrated to Arch for several years, but has become
increasingly frustrated with Systemd, Gnome, RedHat and Ubuntu dominance. It is
believed that there is a need for a distribution that does not pander to ease of
use for casual users at the expense of putting up roadblocks for experienced Unix
veterans.
## Architectures
HHL compiles for the following processor architectures:
* x86
* x86_64
* armv7l
* aarch64
* riscv64

Of the above, HHL is known to boot and run well on x86_64 and aarch64.
Running on other architectures will require more manual work on the part
of the user in order to set up their boot loader.
