+++
title = "Development Restarted"
date = 2022-09-04
[taxonomies]
tags = ["Site News"]
categories = ["Site News"]
+++
Development on HitchHiker Linux had slowed quite a bit over the past year and a half.
It had not entirely stopped, as the base was staying in sync with new versions of the
base packages such as gcc, glibc and the kernel, but no real new development had taken
place. At the point that it was left, hhl was at a state of being *almost* bootable on
x86_64 and Raspberry Pi. It is now officially booting and running on x86_64.
<!-- more -->
Some of the reasons for the hiatus were personal, having been spending too much time on
this project and not enough with family. Others were due to being stalled on a few
(mostly) simple problems. The most daunting seemed at first to be figuring out s6-rc.
This turned out to be not all that complicated in the end, but was complicated by the
documentation leaving out a number of key pieces of information. This often happens in
open source, of course.

While there is no automatic mechanism in place for handling changes to the boot process
and which processes are to be started and shut down, it is happily running on a dual
boot with Arch on one of my laptops and I am happy with s6. It is fast and light. You
don't really notice that it's there, actually.

## Some other changes
I've given up on using The One True Awk and have gone with Gawk instead, due to changes
in Pkgsrc not recognizing that we have a valid Awk installed. This get's frustrating,
but as Gawk is already required to build some of the base packages it also created a
bootstrapping problem and had to be built as part of the temporary toolchain when
building the base system from source. If I can track down the Pkgsrc issue I reserve the
right to go back. We'll see.

The kernel config that will ship with binary sets on x86 is based off of Slackware's
Huge_S kernel. This will allow HitcHiker to boot on most hardware without an initrd,
greatly simplifying development. Users are encouraged to build a kernel suited to their
own hardware.

## Packages, or what is the system like?
On my machine I've currently got both Xfce4 and Mate desktops installed. There are a
large number of WindowManagers also compiled as packages. My only persistent issue at
the moment is that my touchpad is not recognized as such, and is instead treated as a
ps2 mouse. This isn't high on my list of priorities as I'm not a big mouse user to
begin with, but I'd like to track it down and provide a fix.

Other than that issue the system is pretty nice. There are areas where pkgsrc lags
behind Arch and you don't get as up to date libraries, so a few of my other projects
aren't able to compile on HitchHiker yet. But out of curiosity I tried to manually
compile and install Flatpak and was surprised to get it working quite easily. As I'm
in the process of migrating some of my graphical applications to target Gnome
specifically, a couple of them are already almost ready to upload to FlatHub at this
point. Now, I have mixed feelings about Flatpak and containerized anything, but it
does provide a path forward to use HitchHiker as a daily driver and still be able
to do the other development work that I have been engaged in.

I have two machines running periodically compiling packages from Pkgsrc. Currently,
the number of packages that are ready to go is up to 2261. Pkgin seems to be quite
a nice package manager, and the command line is easy to understand compared with,
say, Pacman.
